      subroutine denoise_g3d(cha_ct,cha_sd,cha_t,cha_tn,nd,nt_min,sigma,
     +                       t,x,y)
C***********************************************************************

      character*3
     +          cha_ct,
     +          cha_sd,
     +          cha_t,
     +          cha_tn

      integer   i,
     +          i_0,
     +          j,
     +          j_0,
     +          k,
     +          k_0,
     +          nd,
     +          nt_min

      real*8    data(0:7*nd**3/8-1),
     +          median,
     +          sigma,
     +          t,
     +          x(0:nd-1,0:nd-1,0:nd-1),
     +          xy(0:nd-1,0:nd-1,0:nd-1),
     +          y(0:nd-1,0:nd-1,0:nd-1)

C-----------------------------------------------------------------------

      call fwt_3df(nd,nt_min,x,xy)
      if (cha_sd.eq.'ng') then
         do k=0,nd/2-1
            do j=0,nd/2-1
               do i=nd/2,nd-1
                  data(i+j*nd/2+k*nd**2/4-nd/2)=abs(xy(i,j,k))
               enddo
            enddo
         enddo
         do k=0,nd/2-1
            do j=nd/2,nd-1
               do i=0,nd-1
                  data(i+j*nd+k*nd**2/2-nd**2/2+nd**3/8)=abs(xy(i,j,k))
               enddo
            enddo
         enddo
         do k=nd/2,nd-1
            do j=0,nd-1
               do i=0,nd-1
                  data(i+j*nd+k*nd**2-nd**3/8)=abs(xy(i,j,k))
               enddo
            enddo
         enddo
         sigma=1.d0/.6745d0*median(7*nd**3/8,data)
      elseif (cha_sd.eq.'g') then
         sigma=1.d0
      endif
      if (cha_t.eq.'h') then
         t=sigma*sqrt(2.d0*log(dble(nd**3)))
      elseif (cha_t.eq.'l') then
         if (nd**3.le.32) then
            t=sigma*0.d0
         else
            t=sigma*(.3936d0+.1829d0*log(dble(nd**3))/log(2.d0))
         endif
      endif
      if (cha_ct.eq.'d') then
         i_0=nt_min/2
         j_0=nt_min/2
         k_0=nt_min/2
      elseif (cha_ct.eq.'a&d') then
         i_0=0
         j_0=0
         k_0=0
      endif
      do k=0,k_0-1
         do j=0,j_0-1
            do i=i_0,nd-1
               if (cha_tn.eq.'h') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  endif
               elseif (cha_tn.eq.'s') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  else
                     xy(i,j,k)=sign(abs(xy(i,j,k))-t,xy(i,j,k))
                  endif
               endif
            enddo
         enddo
      enddo
      do k=0,k_0-1
         do j=j_0,nd-1
            do i=0,nd-1
               if (cha_tn.eq.'h') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  endif
               elseif (cha_tn.eq.'s') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  else
                     xy(i,j,k)=sign(abs(xy(i,j,k))-t,xy(i,j,k))
                  endif
               endif
            enddo
         enddo
      enddo
      do k=k_0,nd-1
         do j=0,nd-1
            do i=0,nd-1
               if (cha_tn.eq.'h') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  endif
               elseif (cha_tn.eq.'s') then
                  if (abs(xy(i,j,k)).le.t) then
                     xy(i,j,k)=0.d0
                  else
                     xy(i,j,k)=sign(abs(xy(i,j,k))-t,xy(i,j,k))
                  endif
               endif
            enddo
         enddo
      enddo
      call fwt_3db(nd,nt_min,xy,y)

      return
      end
